#include <stdio.h>
#include <assert.h>
#include <math.h>
#include "odicon.h"

static double (*dfunc)(int,double*);
static double ifunc(int dim, int x[]) { return int_func(dim, dfunc, x); }

double lgconv_minimize_relax(int dim, double func(int dim, double x[]),
			     int init[]) {
    lbfgs_call_int(dim, func, init);
    dfunc = func;
    return lgconv_minimize_IFF(dim, ifunc, init);
}


static double (*lfunc)(int,double*);
static int stored_fix_index;
static int stored_index;
static double lgfunc(int dim, double* x) {
    int i;
    double y[1000];

    for (i=0; i<stored_fix_index; i++) y[i] = x[i];
    y[i] = stored_index;
    for (;    i<dim;              i++) y[i+1] = x[i];
    return lfunc(dim+1, y);
}

double lconv_minimize_relax(int dim, double func(int dim, double x[]),
                            int init[], const int fix_index) {
    int i, y[1000];

    lfunc = func;
    stored_fix_index = fix_index;
    for (i=0; i<fix_index; i++) y[i]   = init[i];
    stored_index = init[i];
    for (i++; i<dim;       i++) y[i-1] = init[i];

    lbfgs_call_int(dim-1, lgfunc, y);
    
    for (i=0; i<fix_index; i++) init[i] = y[i];
    for (i++; i<dim;       i++) init[i] = y[i-1];

    dfunc = func;
    return lconv_minimize_IFF(dim, ifunc, init, fix_index);
}
